<template>
  <div>
    <div v-if="studentQuestionResult">
      <el-row>
        <el-col :span="3"><strong>{{ $t('RESULT.STD_ANSW') }}</strong></el-col>
        <el-col :span="7">{{ $t('RESULT.TOTAL') }} {{ studentQuestionResult.numberOfStudent }} {{ $t('RESULT.ITEM') }}</el-col>
        <div style="margin-bottom:15px;">
        <el-button v-if="resultType !== '실시간'" type="primary" size="small" @click="editMode=!editMode">{{ $t('RESULT.MDF_MODE_N_FF') }}</el-button>
        <el-button v-if="resultType !== '실시간' && detailMode" size="small" @click="detailMode=false">{{ $t('RESULT.SHOW_LESS') }}</el-button>
        <el-button v-if="resultType !== '실시간' && !detailMode" size="small" @click="detailMode=true">{{ $t('RESULT.SHOW_ALL_ANSWS') }}</el-button>
        <el-button v-if="resultType !== '실시간'" size="small" @click="regrade()">{{ $t('RESULT.REMARK') }}</el-button>
        <el-button v-if="resultType !== '실시간' && editMode" type="primary" size="small" @click="totalRegrade()">{{ $t('RESULT.APPY_BAT_SCRS') }}</el-button>
        <el-button v-if="resultType === '실시간'" style="float:right" type="primary" size="small" icon="el-icon-refresh" @click="refresh()">{{ $t('RESULT.REFRESH') }}</el-button>
        </div>
      </el-row>
      <el-row>
        <el-col :span="12">
          <span v-if="studentQuestionResult.type === '객관'" class="table-caption">{{ $t('RESULT.UNIT') }}</span>
          <el-table v-if="studentQuestionResult.type === '객관'"
                    :data="questionResultSummary"
                    :header-cell-style="changeHead"
                    style="margin-bottom: 20px;">
            <el-table-column
              prop="numAnswer"
              :label="$t('RESULT.CRRT_ANSW')"
              align="center">
            </el-table-column>
            <el-table-column
              prop="numPartialAnswer"
              :label="$t('RESULT.PART_CORRT_ANSW')"
              align="center">
            </el-table-column>
            <el-table-column
              prop="numWrongAnswer"
              :label="$t('RESULT.INCRRT_ANSW')"
              align="center">
            </el-table-column>
          </el-table>
        </el-col>
      </el-row>
      <el-table :data="studentQuestionResult.answers"
                :header-cell-style="changeHead"
                :default-sort="{prop: 'user.order', order: 'descending'}">
                <!-- height="500"> -->
        <!-- 미제출 학생 정렬 플래그 -->
        <el-table-column
          label=""
          prop="user.order"
          align="center"
          width="1px"
          >
        </el-table-column>        
        <el-table-column
          :label="$t('RESULT.STD_ID')"
          prop="user.email_id"
          align="center"
          width="200px"
          sortable>
        </el-table-column>
        <el-table-column
          :label="$t('RESULT.STD_NAME')"
          prop="user.name"
          align="center"
          width="200px"
          sortable>
        </el-table-column>
        <!--el-table-column
          v-if="studentQuestionResult.type === '서술'"
          label="첨부 파일"
          align="center">
          <template slot-scope="scope">
            <div v-if="scope.row.files.length !== 0">
              <el-dropdown @command="handleVisible" placement="bottom-start" trigger="click">
                <span class="el-dropdown-link">
                  제출 파일 목록<i class="el-icon-arrow-down el-icon--right"></i>
                </span>
                <el-dropdown-menu slot="dropdown">
                  <div v-for="(file) in scope.row.files" :key="file.file_guid">
                    <el-dropdown-item type="text" :command="file">{{ file.name }}</el-dropdown-item>
                  </div>
                </el-dropdown-menu>
              </el-dropdown>
            </div>
            <div v-else>
              <span>-</span>
            </div>
          </template>
        </el-table-column-->
        <el-table-column
          v-if="questionResult.type !== '멀티미디어' "
          prop="answer"
          :label="$t('RESULT.ANSWER')"
          align="center">
          <template slot-scope="scope">
            <span v-for="(answer, index) in scope.row.answer" class="item" :key="index">
              <!-- 박남훈 강사님 요청으로 answer 전부 표시 -->
              <span
                @click="setDialogVisible(answer)"
                class="description-cursor"
                v-if="!detailMode"
                slot="reference"
              >
                {{ answer.length > 10 ? answer.substring(0,10)+"..." : answer }}
              </span>
              <span
                @click="setDialogVisible(answer)"
                class="description-cursor"
                v-if="detailMode"
                slot="reference"
              >
                {{ answer }}
              </span>
              <!--
              <el-popover
                placement="right"
                trigger="click"
                width="500"
                :content="answer">
              </el-popover>
              -->
            </span>
          </template>
        </el-table-column>

        <el-table-column
          v-if="questionResult.type === '멀티미디어' "
          prop="answer"
          :label="$t('RESULT.ANSWER')"
          align="center">
          <template slot-scope="scope">
            <youtube
              v-if="questionResult.answer_media_type === 'youtube'"
              :video-id="youtubeId(scope.row.answer[0])"
              player-width="500"
              player-height="300"
              :mute="true"
            >
            </youtube>

            <!-- TODO: 클릭시 확대 -->
            <img
              v-if="questionResult.answer_media_type === 'image'"
              :src="getUrl(scope.row.answer)"
              width="300px">

            <div v-if="questionResult.answer_media_type === 'voice'">
              <audio controls :src="scope.row.answer[0]"></audio>
            </div>
          </template>
        </el-table-column>

        <el-table-column
          v-if="questionResult.type === '서술' && autoGradeTeacherScoreList.length > 0"
           label="강사 자동채점 결과"
          align="center">
          <template slot-scope="scope">
            <span v-for="(answer, index) in scope.row.answer" class="item" :key="index">
              <span>{{ autoGradeTeacherScoreList[index] }}</span>
            </span>
          </template>
        </el-table-column>

        <el-table-column
          v-if="questionResult.type === '서술' && autoGradeStudentScoreList.length > 0"
           label="학생 자동채점 결과"
          align="center">
          <template slot-scope="scope">
            <span v-for="(answer, index) in scope.row.answer" class="item" :key="index">
              <span>{{ autoGradeTeacherScoreList[index] }}</span>
            </span>
          </template>
        </el-table-column>

        <!-- <el-table-column
          v-if="studentQuestionResult.type === 'SW'"
          label="결과"
          align="center">
          <template slot-scope="scope">
            <p>{{ scope.row.swResult }}</p>
            <p v-if="scope.row.oj_solution !== undefined">{{ scope.row.oj_solution.time }}ms, {{ scope.row.oj_solution.memory }}KB</p>
            <p v-if="scope.row.swResult === '컴파일 에러'">{{ scope.row.oj_compileinfo.error }}</p>
            <p v-if="scope.row.swResult === '런타임 에러'">{{ scope.row.oj_runtimeinfo.error }}</p>
          </template>
        </el-table-column> -->
        <el-table-column
          v-if="studentQuestionResult.type === 'SW'"
          :label="$t('STUDENT_MENU.VIEW_RESULTS')"
          align="center"
        >
          <template slot-scope="scope">
            <el-button
              @click="showResult(scope.row)">{{ $t('STUDENT_MENU.VIEW_RESULTS') }}</el-button>
          </template>
        </el-table-column>
        <el-table-column
          v-if="questionResult.type !== '멀티미디어' "
          prop="count"
          label="신뢰도"
          align="center">
          
        </el-table-column>
        <el-table-column
          prop="score"
          :label="$t('RESULT.SCORE')"
          width="150px"
          align="center">
            <template slot-scope="scope">
              <div>
                <el-input
                  v-if="editMode == true"
                  placeholder="Please input"
                  v-model="scope.row.score"
                  type="number"
                  min="0"
                  :max="studentQuestionResult.score" />
                <p v-if="editMode == false">
                  {{ scope.row.score }}
                </p>
              </div>
            </template>
        </el-table-column>
        <el-table-column
          label=""
          width="100px"
          align="center">
          <template slot-scope="scope">
            <el-button
                      v-if="editMode == true"
                      type="info"
                      plain
                      size="small"
                      @click="scoreSubmit(scope.row.score, scope.row.student_answer_log_id)">
              {{ $t('NOTE.CONFIRM') }}
            </el-button>
          </template>
        </el-table-column>
      </el-table>

      <!--
      <el-dialog
        :visible.sync="currentFile.visible"
        :before-close="handleClose"
        custom-class="dialog">
        <div v-if="currentFile.type === `.mp4`">
          <vue-plyr ref="player">
            <video>
              <source :src="url" type="video/mp4">
            </video>
          </vue-plyr>
        </div>
        <div v-else-if="['.jpg','.png','.gif'].includes(currentFile.type)">
          <img :src="url" width="100%">
        </div>
        <div v-else>
          <a :href="url" target="_blank" download>{{ currentFile.name }}</a>
        </div>
      </el-dialog>
      -->

      <el-dialog
        :title="$t('QUESTION.ANSWER_DETAIL')"
        :visible.sync="dialogVisible"
        center
        width="75%">
        <pre style="white-space:pre-wrap;"> {{ dialogContents }} </pre>
        <span slot="footer" class="dialog-footer">
          <el-button @click="dialogVisible = false">{{ $t('DASHBOARD.QUIT') }}</el-button>
        </span>
      </el-dialog>
      <el-dialog
        :title="$t('STUDENT_MENU.VIEW_RESULTS')"
        width="40%"
        :visible.sync="resultVisible"
        :close-on-click-modal="false"
        :close-on-press-escape="false">
        <div>{{ `${$t('ITEM.NAME')}: ${questionResult.itemName}`}}</div>
        <div>{{ `${$t('DASHBOARD.STUDENT_NAME')}: ${currentRow ? currentRow.user.name : ''}`}}</div>
        <el-table
          :data="swAnalysis">
          <el-table-column
            :label="$t('DASHBOARD.EVALUATION_ITEM')"
            prop="key"
            align="center">
          </el-table-column>
          <el-table-column
            :label="$t('DASHBOARD.EVALUATION_RESULT')"
            prop="value"
            align="center">
          </el-table-column>
          <el-table-column
            :label="`${$t('DASHBOARD.AVERAGE')}(${$t('DASHBOARD.STANDARD_DEVIATION')})`"
            align="center">
            <template slot-scope="scope">
              {{ `${scope.row.mean}(${scope.row.sd})` }}
            </template>
          </el-table-column>
        </el-table>
      </el-dialog>
    </div>
  </div>
</template>

<style lang="scss" scoped>
  .choices {
    padding-right: 25px;
    .index {
      color: #888888;
    }
  }
  .el-row {
    padding-bottom: 0px;
    padding-left: 0px;
    padding-right: 0px;
  }
  .item + .item:before {
    content: ", ";
  }
  .table-caption {
    float: right;
  }
  .el-dropdown-link {
    cursor: pointer;
    color: #409EFF;
  }
  .el-icon-arrow-down {
    font-size: 12px;
  }
  .description-cursor {
    cursor: pointer;
  }
</style>
<style src="vue-plyr/dist/vue-plyr.css">
</style>


<script>
  import { mapActions, mapState, mapGetters } from 'vuex';
  import { getIdFromURL } from 'vue-youtube-embed';
  import questionService from '../../services/questionService';
  import fileService from '../../services/fileService';
  import { baseUrl } from '../../services/config';
  import utils from '../../utils';
  import { EventBus } from '../../event-bus';


  export default {
    name: 'LectureQuestionResult',
    props: ['classId', 'lectureId', 'itemId', 'resultType'],
    data() {
      return {
        dialogVisible: false,
        editMode: true,
        detailMode: false, // true면 상세 보기, false면 간략히 보기
        dialogContents: '',
        autoGradeStudentScoreList: [],
        autoGradeTeacherScoreList: [],
        activeTab: 'question',
        questionId: '',
        questionResultSummary: [{
          numAnswer: null,
          numPartialAnswer: null,
          numTotal: null,
        }],
        resultVisible: false,
        studentQuestionResult: undefined,
        currentFile: {
          visible: false,
          name: undefined,
          type: undefined,
          path: undefined,
          player: undefined,
        },
        blobURL: [],
        temp: undefined,
        swAnalysis: [],
        currentRow: null,
      };
    },
    computed: {
      ...mapState('grading', [
        'theResult',
        'questionResult',
      ]),
      ...mapGetters('NNclass', [
        'currentTeachingClass',
      ]),
      ...mapGetters('class', [
        'numberOfStudentInClass',
      ]),
    },
    async created() {
      const vm = this;
      // TODO: 부모 component에서 받아 오는 형식으로 수정
      await vm.getClassTotalResult({
        lectureId: vm.lectureId,
        classId: vm.classId,
        isStudent: false,
      });
      vm.getQuestionResult({
        itemId: vm.itemId,
      });
      vm.studentQuestionResult = vm.questionResult;
      vm.studentQuestionResult.answers.forEach(x=>x.count = ((1/x.count)*100).toFixed(2) + "%")
      vm.questionId = vm.studentQuestionResult.questionId; // 재사용을 위해 저장함
      const res = await questionService.NNgetQuestionResult({
        questionId: vm.questionId,
        classId: vm.classId,
      });

      // 멀티미디어 - 목소리의 경우, 서버에 guid를 전송하고, 파일을 받아옴
      if (vm.studentQuestionResult.answer_media_type === 'voice') {
        for (const answer of vm.studentQuestionResult.answers) { // eslint-disable-line
          answer.answer.splice(0, 1, await vm.getBlobUrl(answer.answer[0]));
        }
      }

      // 실시간 - 미제출 학생 표기 모듈
      if (vm.resultType === '실시간') {
        // email_id 목록을 추출한다.
        const emailList = vm.studentQuestionResult.answers.map(x => x.user.email_id);

        res.data.login_students.forEach((element) => {
          // res.data.login_students.email_id가 추출한 목록에 있는지 보고 없으면 push
          if (!emailList.includes(element.email_id)) {
            vm.studentQuestionResult.answers.push({
              answer: ['미제출'],
              user: element,
            });
          }
        });
      }

      const numAnswer = res.data.num_students_answer;
      const numPartialAnswer = res.data.num_students_partial_answer;
      const numTotal = res.data.num_students_total;
      vm.questionResultSummary[0].numAnswer = numAnswer;
      vm.questionResultSummary[0].numPartialAnswer = numPartialAnswer;
      vm.questionResultSummary[0].numWrongAnswer = numTotal - numAnswer - numPartialAnswer;

      EventBus.$on('autoGradingComplete', vm.autoGradingComplete);
    },
    methods: {
      ...mapActions('grading', [
        'getClassTotalResult',
        'getQuestionResult',
        'regradeQuestion',
      ]),
      ...mapActions('NNclass', [
        'putScore',
      ]),
      youtubeId(URL) {
        return typeof URL === 'string' ? getIdFromURL(URL) : '';
      },
      async getBlobUrl(fileGuid) {
        const file = await fileService.getFile({ guid: fileGuid });
        const blobURL = URL.createObjectURL(file.data);
        return blobURL;
      },
      setDialogVisible(contents) {
        const vm = this;
        vm.dialogContents = contents;
        vm.dialogVisible = true;
      },
      autoGradingComplete(data) {
        const vm = this;

        vm.autoGradeStudentScoreList.length = 0;
        data.student.forEach((element) => {
          vm.autoGradeStudentScoreList.push(element.score);
        });

        vm.autoGradeTeacherScoreList.length = 0;
        data.lecturer.forEach((element) => {
          vm.autoGradeTeacherScoreList.push(element.score);
        });
      },
      async regrade() {
        const vm = this;
        await vm.regradeQuestion({
          questionId: vm.questionId,
        });
      },
      async refresh() {
        const vm = this;
        await vm.getClassTotalResult({
          lectureId: vm.lectureId,
          classId: vm.classId,
          isStudent: false,
        });
        vm.getQuestionResult({
          itemId: vm.itemId,
        });

        vm.studentQuestionResult = vm.questionResult;
        const questionId = vm.studentQuestionResult.questionId;
        const res = await questionService.NNgetQuestionResult({
          questionId,
          classId: vm.classId,
        });

        // 실시간 - 미제출 학생 표기 모듈
        if (vm.resultType === '실시간') {
          // email_id 목록을 추출한다.
          const emailList = vm.studentQuestionResult.answers.map(x => x.user.email_id);

          res.data.login_students.forEach((element) => {
            // res.data.login_students.email_id가 추출한 목록에 있는지 보고 없으면 push
            if (!emailList.includes(element.email_id)) {
              vm.studentQuestionResult.answers.push({
                order: '0', // 미제출 학생 정렬용 플래그
                answer: ['미제출'],
                user: element,
              });
            }
          });
        }

        const numAnswer = res.data.num_students_answer;
        const numPartialAnswer = res.data.num_students_partial_answer;
        const numTotal = res.data.num_students_total;
        vm.questionResultSummary = [{
          numAnswer: null,
          numPartialAnswer: null,
          numWrongAnswer: null,
        }];
        vm.questionResultSummary[0].numAnswer = numAnswer;
        vm.questionResultSummary[0].numPartialAnswer = numPartialAnswer;
        vm.questionResultSummary[0].numWrongAnswer = numTotal - numAnswer - numPartialAnswer;
      },
      changeHead() {
        return { backgroundColor: '#EAEAEA' };
      },
      async scoreSubmit(score, id) { // eslint-disable-line
        const vm = this;
        if (score < 0 || score > vm.studentQuestionResult.score) {
          vm.$notify({
            title: 'Error',
            message: vm.$t('NOTIFY.CHCK_SCR_RANGE'),
            type: 'error',
            duration: 2000,
          });
          return;
        }
        const res = await vm.putScore({ id, score });
        if (res && res.status === 200) {
          vm.$notify({
            title: vm.$t('NOTIFY.COMP_MODIFY'),
            message: vm.$t('NOTIFY.SUC_MODI_COMP'),
            type: 'success',
            duration: 1000,
          });
        }
      },
      async totalRegrade() {
        const vm = this;
        let ifNull = false; // null 값이 들어온다면 true -> score 알림 띄워야 함
        let ifRangeOver = false; // 범위를 초과했다면 true -> 알림창 띄워야 함
        vm.studentQuestionResult.answers.forEach((x) => {
          if (x.score === null || x.score === '') {
            ifNull = true;
          } else if (x.score < 0 || x.score > vm.studentQuestionResult.score) {
            ifRangeOver = true;
          }
        });
        if (ifNull === true) { // null 값 있다면 알림 띄우기
          vm.$notify({
            title: 'Error',
            message: vm.$t('NOTIFY.ENT_ALL_STU_SCO'),
            type: 'error',
            duration: 2000,
          });
        } else if (ifRangeOver === true) { // 범위 초과했다면 알림 띄우기
          vm.$notify({
            title: 'Error',
            message: vm.$t('NOTIFY.CHCK_SCR_RANGE'),
            type: 'error',
            duration: 2000,
          });
        } else { // 점수 일괄 적용
          for (let i = 0; i < vm.studentQuestionResult.answers.length; i += 1) {
            const x = vm.studentQuestionResult.answers[i];
            await vm.putScore({ // eslint-disable-line
              id: x.student_answer_log_id,
              score: x.score,
            });
          }
          vm.$notify({
            title: vm.$t('NOTIFY.COMP_MODIFY'),
            message: vm.$t('NOTIFY.SUC_MODI_COMP'),
            type: 'success',
            duration: 1000,
          });
        }
      },
      handleVisible(file) {
        const vm = this;
        vm.currentFile.name = file.name;
        vm.currentFile.type = file.file_type;
        vm.currentFile.path = file.client_path;
        if (['.mp4', '.jpg', '.png', '.gif'].includes(vm.currentFile.type)) {
          vm.currentFile.visible = true;
        } else {
          utils.downloadFile(vm.url, vm.currentFile.name);
        }
      },
      handleClose() {
        const vm = this;
        vm.currentFile.visible = false;
        if (vm.currentFile.type === '.mp4') {
          vm.currentFile.player = vm.$refs.player.player;
          vm.currentFile.player.stop();
        }
      },
      getUrl(arg) {
        return baseUrl + arg;
      },
      showResult(row) {
        const vm = this;
        const analyses = vm.studentQuestionResult.answers.map(answer => {
          if (answer.oj_solution.oj_analyses && answer.oj_solution.oj_analyses.length) {
            answer.oj_solution.oj_analyses.sort((a, b) => new Date(b.created_at) - new Date(a.created_at));
          }
          return answer.oj_solution.oj_analyses[0];
        }).filter(el => el);
   
        let datas = [];
        const means = {};
        const sds = {};
        const keys = ['ast_depth', 'ast_node_number', 'num_assignment', 'num_branch_total', 'num_class', 'num_comparision_operator', 'num_function_declared', 'num_function_used', 'num_loop_total', 'num_operator', 'num_var_declared', 'num_var_used'];
        row.oj_solution.oj_analyses.sort((a, b) => new Date(b.created_at) - new Date(a.created_at));

        // mean
        keys.forEach(key => {
          analyses.forEach(analysis => {
            if (!means[key]) {
              means[key] = analysis[key];
            } else {
              means[key] += analysis[key];
            }
            if (analysis && analysis.length) {
              means[key] /= analyses.length;
            }
          });
        });

        // sd
        keys.forEach(key => {
          analyses.forEach(analysis => {
            if (!sds[key]) {
              sds[key] = (analysis[key] - means[key]) * (analysis[key] - means[key]);
            } else {
              sds[key] += (analysis[key] - means[key]) * (analysis[key] - means[key]);
            }
            if (analysis && analysis.length) {
              sds[key] = Math.sqrt(sds[key] / analysis.length);
            }
          });
        });

        datas = keys.map(key => ({
          key,
          value: row.oj_solution.oj_analyses[0][key],
          sd: sds[key],
          mean: means[key]
        }));

        vm.currentRow = row;
        vm.swAnalysis = datas;
        vm.resultVisible = true;
      }
    },
  };
</script>
